#ifndef LIGNEFAISCEAU_SEEN
#define LIGNEFAISCEAU_SEEN

#include "dataManager.h"
#include "abstractElement.h"
#include "nomdElements.h"
#include "GWt_pspaApplication.h"
#include "GWt_abstractElement.h"
#include "GWt_dropZoneLigneFaisceau.h"

#include <Wt/WApplication>
#include <Wt/WPushButton>
#include <Wt/WHBoxLayout>
#include <Wt/WContainerWidget>

using namespace Wt;

class Compteur {
    int n_;
    
    public :
    Compteur() {n_= 0;}
    int incr() {return ++n_;}
};

class GWt_LigneFaisceau : public WContainerWidget
{
    WHBoxLayout* ligneFaisceauLayout_;
    PspaApplication* pspa_;
    Compteur *nObjets_;
    
    public :
    
    GWt_LigneFaisceau() {;}
    GWt_LigneFaisceau(PspaApplication*);
    
    /**
     
     Add an element at a position inside the beam line.
     @param eType : type of element
     @param dropContainer : origin of the drop event
     -
     Special case, when first element is created, we add a drop zone at the end and beginning of the drop zone
     and we center everything
     */
    void addElement(typedElement eType, GWt_dropZoneLigneFaisceau* dropContainer);
    
    ~GWt_LigneFaisceau() {
        if(nObjets_ != NULL) delete[] nObjets_;
    }
    
    void restoreElementCollectionFromDataManager();
    void clickEvent(WContainerWidget*);
    void deleteElement(WContainerWidget*);
    private :
    void manageLineFaisceauLayout();
    
    
};

#endif
