#ifndef PSPA_SEEN
#define  PSPA_SEEN

#include <cstdlib>
#include <list>

#include <Wt/WApplication>
#include <Wt/WEnvironment>
#include <Wt/WContainerWidget>
#include <Wt/WText>
#include <Wt/WPanel>
#include <Wt/WComboBox>
#include <Wt/WPushButton>
#include <Wt/WDialog>
#include <Wt/WPdfImage>
#include <Wt/Chart/WCartesianChart>
#include <Wt/WLength>

#include "GWt_dialog.h"
#include "dataManager.h"
#include "GWt_console.h"
#include "GWt_abstractElementFactory.h"

using namespace Wt;

/*
 * ESSAI PSPA
 */
class PspaApplication : public WApplication
{
    
    typedef struct {
        WLineEdit* debut;
        WLineEdit*  fin;
        WComboBox* selection;
        WContainerWidget* ligneDeWidget;
    } GWt_sectionToExecute;
    
    private :
    
    dataManager* dtmanage_;
    string nameOfCase_;
    string workingDir_;
    WDialog* dialogSave_;
    WDialog* dialogOpen_;
    WLineEdit* saveNameEdit_;
    WLineEdit* openNameEdit_;
    
    
    // WContainerWidget* console_;
    WWidget* globalParam_;
    WWidget* beamLine_;
    // WContainerWidget* leDessin_;
    GWt_dialog* graphicsDialog_;
    
    WPushButton *exec_go_;
    WText* probleme_;
    WComboBox* choixElementDessin_;
    WComboBox* choixTypeDessinFaisceau_;
    WComboBox* choixEnveloppeDessin_;
    WContainerWidget* toto_;
    WContainerWidget* contenuSections_;
    list<GWt_sectionToExecute*> selectedSections_;
    WFileUpload* uploadFileSelectorWidget_;
    GWt_console* console_;
    GWt_abstractElementFactory* abstractElementFactory_;
    
    
    WText*   createTitle(const WString&);
    WWidget* createPalette();
    WWidget* createBeamLine();
    WWidget* createGlobalParamWidget();
    WWidget* createExecuteWidget();
    WContainerWidget* createDrawingWidget();
    
    void createDragImage(const char *url,const char *smallurl,const char *mimeType,WContainerWidget *p,WString name);
    void executer();
    void sauver();
    void dialogSaveDone(WDialog::DialogCode code);
    void dialogOpenDone(WDialog::DialogCode code);
    void restaurer();
    void chargerConfig();
    void openFileSelector();
    void fileTooLarge();
    void dessiner();
    
    void addSectionToExecuteW();
    void deleteSectionToExecuteW();
    void checkSectionSelection();
    void disableSectionExecute();
    bool areDataCoherent();
    void dialogOnGraphics();
    void faireDessin();
    void faireDessinParmela(WContainerWidget* toto, particleBeam* beam);
    void faireDessinTransport(WContainerWidget* toto, particleBeam* beam);
    
    void dessinerEnveloppe();
    void faireDessinEnveloppe(WContainerWidget* toto, string type);
    void scatterPlot1D(WContainerWidget* toto, vector<double>& xcor, vector<double>& ycor);
    
    bool removeExtensionFromConfigName(string& config);
    
    void dessinerHistogramme();
    
    public :
    
    PspaApplication(const WEnvironment& env);
    
    inline dataManager* getDataManager() const  {
        return dtmanage_;
    }
    
    // void addConsoleMessage(WString msg);
    
    void updateSelections();
    string getSelection();
};
#endif
